USE [AdventureWorks2012]
GO

IF EXISTS(select * from sys.indexes where name like 'idx_SalesOrderHeaderEnlarged_PT_rowguid')
	DROP INDEX idx_SalesOrderHeaderEnlarged_PT_rowguid ON [Sales].[SalesOrderHeaderEnlarged_PT]
GO

CREATE NONCLUSTERED INDEX idx_SalesOrderHeaderEnlarged_PT_rowguid ON [Sales].[SalesOrderHeaderEnlarged_PT]
(
	[RowGuid] 
)ON Demo3_Scheme([OrderDate])

select object_name(a.object_id) AS object_name,
 a.index_id,
 b.name,
 b.type_desc,
 a.partition_number,
 a.avg_fragmentation_in_percent
FROM sys.dm_db_index_physical_stats (DB_ID(), NULL, NULL , NULL, 'LIMITED') a
JOIN sys.indexes b on a.object_id = b.object_id and a.index_id = b.index_id
WHERE a.object_id = object_id('Sales.SalesOrderHeaderEnlarged_PT')
AND b.name like 'idx_SalesOrderHeaderEnlarged_PT_rowguid'
order by object_name(a.object_id), a.index_id, b.name, b.type_desc, a.partition_number;

/* Fragment Partition #7 with one single update query */
UPDATE Sales.SalesOrderHeaderEnlarged_PT
SET rowguid = newid() 
WHERE orderdate > '2011-01-01 00:00:00.000'
AND orderdate < '2012-01-01 00:00:00.000';


select object_name(a.object_id) AS object_name,
 a.index_id,
 b.name,
 b.type_desc,
 a.partition_number,
 a.avg_fragmentation_in_percent
FROM sys.dm_db_index_physical_stats (DB_ID(), NULL, NULL , NULL, 'LIMITED') a
JOIN sys.indexes b on a.object_id = b.object_id and a.index_id = b.index_id
WHERE a.object_id = object_id('Sales.SalesOrderHeaderEnlarged_PT')
AND b.name like 'idx_SalesOrderHeaderEnlarged_PT_rowguid'
order by object_name(a.object_id), a.index_id, b.name, b.type_desc, a.partition_number;

ALTER INDEX idx_SalesOrderHeaderEnlarged_PT_rowguid
ON Sales.SalesOrderHeaderEnlarged_PT
REBUILD Partition = 7
WITH (ONLINE=ON) -- Comming in SQL 2014


select object_name(a.object_id) AS object_name,
 a.index_id,
 b.name,
 b.type_desc,
 a.partition_number,
 a.avg_fragmentation_in_percent
FROM sys.dm_db_index_physical_stats (DB_ID(), NULL, NULL , NULL, 'LIMITED') a
JOIN sys.indexes b on a.object_id = b.object_id and a.index_id = b.index_id
WHERE a.object_id = object_id('Sales.SalesOrderHeaderEnlarged_PT')
AND b.name like 'idx_SalesOrderHeaderEnlarged_PT_rowguid'
order by object_name(a.object_id), a.index_id, b.name, b.type_desc, a.partition_number;



-- Each Partition can be compressed differently
ALTER INDEX idx_SalesOrderHeaderEnlarged_PT_rowguid
ON Sales.SalesOrderHeaderEnlarged_PT
REBUILD Partition = 6
WITH (DATA_COMPRESSION = PAGE); 
GO

ALTER INDEX idx_SalesOrderHeaderEnlarged_PT_rowguid
ON Sales.SalesOrderHeaderEnlarged_PT
REBUILD Partition = 7
WITH (DATA_COMPRESSION = ROW); 
GO

SELECT index_id, partition_id, data_compression_desc
FROM sys.partitions p
WHERE OBJECT_ID('Sales.SalesOrderHeaderEnlarged_PT') = p.object_id

/* SQL 2008 - Manualy create and manage filter for statistics */
CREATE STATISTICS TP_FilteredStats
ON Sales.SalesOrderHeaderEnlarged_PT ([ShipDate])
WHERE orderdate > '2011-01-01 00:00:00.000'
AND orderdate < '2012-01-01 00:00:00.000'
WITH FULLSCAN, NORECOMPUTE;

-- Cannot do incremental stats on filtered statistics
CREATE STATISTICS TP_FilteredStats2
ON Sales.SalesOrderHeaderEnlarged_PT ([ShipDate])
WHERE orderdate > '2011-01-01 00:00:00.000'
AND orderdate < '2012-01-01 00:00:00.000'
WITH FULLSCAN, NORECOMPUTE,INCREMENTAL = ON;

/* SQL 2014 CTP2 - Incremental Statistics Update by Partition */
UPDATE STATISTICS Sales.SalesOrderHeaderEnlarged_PT(idx_SalesOrderHeaderEnlarged_PT_rowguid)
    WITH FULLSCAN, INCREMENTAL = ON --currently cannot specify partition




